using System;

namespace MyTM
{
	/// <summary>
	/// Transaction Manager 
  /// </summary>
 public class MyTM : System.MarshalByRefObject, TP.TM
{
	 ///Constructor
	public MyTM()
	{
		System.Console.WriteLine( "Transaction Manager instantiated" );
	}
	[System.Serializable()]
	class Transaction : TP.Transaction
	{
	}
/// <summary>
/// 
/// </summary>
/// <returns></returns>
	public TP.Transaction Start()
	{
		Transaction context = new Transaction();
		System.Console.WriteLine( string.Format( "Transaction {0} started", context.Id ));
		return context;
	}

	/// <summary>
	/// call from WC in response to a client's commit
	/// </summary>
	/// <param name="context"></param>

	public void Commit( TP.Transaction context )
	{
		System.Console.WriteLine( string.Format( "Transaction {0} commited", context.Id ));
	}

	/// <summary>
	/// call from WC in response to a client's abort
	/// </summary>
	/// <param name="context"></param>

	public void Abort( TP.Transaction context )
	{
		System.Console.WriteLine( string.Format( "Transaction {0} aborted", context.Id ));
	}
	/// <summary>
	 /// called by an RM.
	 ///This method notifies the TM that it is involved in a given transaction
	 ///The TM remembers wich RM enlisted which transaction.
	/// </summary>
	/// <param name="context"></param>

	public void Enlist( TP.Transaction context )
	{
		System.Console.WriteLine( string.Format( "Transaction {0} enlisted", context.Id ));
	}

	static void Main( string [] args )
	{
		System.Runtime.Remoting.Channels.Http.HttpChannel channel = new System.Runtime.Remoting.Channels.Http.HttpChannel( 8081 );
		System.Runtime.Remoting.Channels.ChannelServices.RegisterChannel( channel );
        System.Runtime.Remoting.RemotingConfiguration.RegisterWellKnownServiceType
	  (	       	Type.GetType("MyTM.MyTM")                       // full type name
	        ,	"TM.soap"						// URI
		,	System.Runtime.Remoting.WellKnownObjectMode.Singleton	// instancing mode
		);
		while( true )
			System.Threading.Thread.Sleep( 100000 );
	}
}
}
